package garcia.alex.talia.entity;

import garcia.alex.talia.graphics.Screen;
import garcia.alex.talia.level.Level;

import java.util.Random;

public abstract class Entity {
	
	public int x, y;
	private boolean removed = false;
	protected Level level;
	protected final Random random = new Random();
	
	public void update(){
		
	}
	
	public void render(Screen screen){
		
	}
	
	public void remove(){//removes the entity from a level
		removed = true;
	}
	
	public boolean isRemoved(){
		return removed;
	}
	
	public void init(Level level){//initialized
		this.level = level;
	}

}
