package garcia.alex.talia.entity.mob;

import garcia.alex.talia.entity.Entity;
import garcia.alex.talia.entity.projectile.Projectile;
import garcia.alex.talia.entity.projectile.WizardProjectile;
import garcia.alex.talia.graphics.Sprite;

public abstract class Mob extends Entity{
	
	protected Sprite sprite;
	protected int dir = 2;//direction
	protected boolean moving = false;
		
	public void move(int xa, int ya){
		if(xa != 0 && ya != 0){
			move (xa, 0);
			move (0, ya);
			return;
		}
		
		if(xa > 0)dir = 1;
		if(xa < 0)dir = 3;
		if(ya > 0)dir = 2;
		if(ya < 0)dir = 0;
		
		if(!collision(xa, ya)){
		x += xa;
		y += ya;
		}//end collision if_else statement
	}
	
	public void update(){
		
	}
	
	protected void shoot(int x, int y, double dir){
		Projectile p = new WizardProjectile(x, y, dir);
		level.add(p);
		
	}
	
	public void render(){
		
	}
	
	private boolean collision(int xa, int ya) {
		boolean solid = false;
		for( int c = 0; c < 4; c++){
			int xt = ((x + xa) + c % 2 * 9 + 3) / 16;//deals with collision box of the mob
			int yt = ((y + ya) + c / 2 * 5 + 10) / 16;//values for a player (note * 15 will make the whole of a 16x16 sprite collide)
			
			if(level.getTile(xt, yt).solid()) solid = true;
		}
		return solid;
	}

}
