package garcia.alex.talia.entity.mob;

import garcia.alex.talia.Game;
import garcia.alex.talia.entity.projectile.Projectile;
import garcia.alex.talia.entity.projectile.WizardProjectile;
import garcia.alex.talia.graphics.Screen;
import garcia.alex.talia.graphics.Sprite;
import garcia.alex.talia.input.Keyboard;
import garcia.alex.talia.input.Mouse;

public class Player extends Mob{
	
	private Keyboard input;
	private Sprite sprite;
	private int anim = 0;//animate variable
	private boolean walking = false;
	private int fireRate = 0;
	
	public Player(Keyboard input){//creates player at top left
		this.input = input;
		sprite = Sprite.playerd;
	}
	
	public Player (int x, int y, Keyboard input){//creates player at specified location
		this.x = x;
		this.y = y;
		this.input = input;
		sprite = Sprite.playerd;
		fireRate = WizardProjectile.FIRE_RATE;
		
	}
	
	public void update(){
		if (fireRate > 0) fireRate --;
		int xa = 0, ya = 0;
		if (anim < 7500) anim++;
		else anim = 0;//fixes crash for long-running games
		if(input.up) ya--;
		if(input.down) ya++;
		if(input.left) xa--;
		if(input.right) xa++;
		
		if (xa != 0 || ya != 0) {
			walking = true;
			move(xa, ya);
		}else{
			walking = false;
		}
		clear();
		updateShooting();
	}
	
	private void clear() {
		for (int i = 0; i < level.getProjectiles().size(); i ++){
			Projectile p = level.getProjectiles().get(i);
			if (p.isRemoved()) level.getProjectiles().remove(i);
		}
		
	}

	private void updateShooting(){
		if(Mouse.getB() == 1 && fireRate <= 0){
			double dx = Mouse.getX() - Game.getWindowWidth() / 2;		
			double dy = Mouse.getY() - Game.getWindowHeight() / 2;		
			double dir = Math.atan2(dy, dx);
			shoot(x, y, dir);
			fireRate = WizardProjectile.FIRE_RATE;
			
		}
	}
	
	public void render(Screen screen){
		if(dir == 0){
			if (walking){
				if (anim % 40 >= 0 && anim % 40 <= 9)sprite = Sprite.playeru0;
				else if (anim % 40 >= 10 && anim % 40 <= 19)sprite = Sprite.playeru;
				else if (anim % 40 >= 20 && anim % 40 <= 29)sprite = Sprite.playeru1;
				else if (anim % 40 >= 30 && anim % 40 <= 39)sprite = Sprite.playeru;
				else sprite = Sprite.playeru;
			}//end walking condition
			else sprite = Sprite.playeru;
		}//end direction (0) condition
		if(dir == 1){
			if (walking){
				if (anim % 40 >= 0 && anim % 40 <= 9)sprite = Sprite.playerr0;
				else if (anim % 40 >= 10 && anim % 40 <= 19)sprite = Sprite.playerr;
				else if (anim % 40 >= 20 && anim % 40 <= 29)sprite = Sprite.playerr1;
				else if (anim % 40 >= 30 && anim % 40 <= 39)sprite = Sprite.playerr;
				else sprite = Sprite.playerr;
			}//end walking condition
			else sprite = Sprite.playerr;
		}//end direction (1) condition

		if(dir == 2){
			if (walking){
				if (anim % 40 >= 0 && anim % 40 <= 9)sprite = Sprite.playerd0;
				else if (anim % 40 >= 10 && anim % 40 <= 19)sprite = Sprite.playerd;
				else if (anim % 40 >= 20 && anim % 40 <= 29)sprite = Sprite.playerd1;
				else if (anim % 40 >= 30 && anim % 40 <= 39)sprite = Sprite.playerd;
				else sprite = Sprite.playerd;
			}//end walking condition
			else sprite = Sprite.playerd;
		}//end direction (2) condition
		if(dir == 3){
			if (walking){
				if (anim % 40 >= 0 && anim % 40 <= 9)sprite = Sprite.playerl0;
				else if (anim % 40 >= 10 && anim % 40 <= 19)sprite = Sprite.playerl;
				else if (anim % 40 >= 20 && anim % 40 <= 29)sprite = Sprite.playerl1;
				else if (anim % 40 >= 30 && anim % 40 <= 39)sprite = Sprite.playerl;
				else sprite = Sprite.playerl;
			}//end walking condition
			else sprite = Sprite.playerl;
		}//end direction (3) condition
		screen.renderPlayer(x, y, sprite);		
	}//end render
	
}//end player class
