package garcia.alex.talia.entity.particle;

import garcia.alex.talia.entity.Entity;
import garcia.alex.talia.graphics.Screen;
import garcia.alex.talia.graphics.Sprite;

public class Particle extends Entity{
	
	private Sprite sprite;
	private int life;
	private int time = 0;
	protected double xx, yy, zz;//origional locations
	protected double xa, ya, za;//new locations
	
	public Particle(int x, int y, int life){//handles particle stuff other than amount
		this.x = x;
		this.y = y;
		this.xx = x;
		this.yy = y;
		this.life = life + (random.nextInt(30) - 15);
		sprite = Sprite.normalParticle;
		
		this.xa = random.nextGaussian();
		this.ya = random.nextGaussian();
		this.zz = random.nextFloat() + 2.0;//makes particles go down - gravity
	}
	
	
	
	public void update(){
		time++;
		if (time >= Integer.MAX_VALUE - 100) time = 0;//prevents crashes
		if (time > life)remove();
		za -= 0.1;// ads a curve to downward moving particles
		
		if (zz < 0){
			zz = 0;
			za *= -.625;//reverses direction of particle
			xa *= .2;
			ya *= .2;
		}
		
		move(xx + xa, (yy + ya) + (zz + za));
		
	}
	
	private void move(double x, double y) {
		if(collision(x, y)){
			this.xa *= -.5;
			this.ya *= -.5;
			this.za *= -.5;
		}
		this.xx += xa;
		this.yy += ya;
		this.zz += za;
	}

	public boolean collision(double x, double y) {
		boolean solid = false;
		for( int c = 0; c < 4; c++){
			double xt = (x - c % 2 * 16) / 16;//deals with collision box of projectile
			double yt = (y - c / 2 * 16) / 16;
			int ix = (int)Math.ceil(xt);//left collision
			int iy = (int)Math.ceil(yt);//up collision
			if (c % 2 == 0) ix = (int)Math.floor(xt);//right collision
			if (c / 2 == 0) iy = (int)Math.floor(yt);//down collision

			if(level.getTile( ix, iy).solid()) solid = true;
		}
		return solid;
	}

	public void render(Screen screen){
		screen.renderSprite((int) xx - 1, (int) yy - (int)zz - 1, sprite, true);
		
	}
	
}//end particle class
