package garcia.alex.talia.entity.projectile;

import garcia.alex.talia.entity.spawner.ParticleSpawner;
import garcia.alex.talia.graphics.Screen;
import garcia.alex.talia.graphics.Sprite;

public class WizardProjectile extends Projectile {
	
	public static final int FIRE_RATE = 15;// higher values are slower
	
	public WizardProjectile(int x, int y, double dir){
		super (x, y, dir);
		range = r.nextInt(100) + 150;
		speed = 4;//makes projectile move faster
		damage = 20;
		sprite = Sprite.fireball;
		
		nx = speed * Math.cos(angle);//used to calculate angle
		ny = speed * Math.sin(angle);
	}
	
	public void update(){
		if(level.tileCollision((int)(x + nx), (int)(y + ny), 4, 6, 6)) {
			level.add(new ParticleSpawner((int)x + 8, (int)y + 8, 50, 30, level));
			remove();
		}
		move();
	}
	
	public void render(Screen screen){
		screen.renderSprite((int)x, (int)y, sprite, true);
	}
	
	protected void move() {
		x += nx;
		y += ny;
		
		if (distance() > range) remove();
	}
	
	private double distance(){
		double distance = 0;
		distance = Math.sqrt(Math.abs((xOrigin - x) * (xOrigin - x) + (yOrigin - y) * (yOrigin - y)));
		return distance;
	}
	
}
