package garcia.alex.talia.graphics;

public class Sprite {
	
		/*
		 * These are all of the declared and/or initialized variables
		 */
	public final int SIZE;
	private int x, y;
	private int width, height;
	public int[] pixels;
	private SpriteSheet sheet;
	
	//tiles
	public static Sprite plain1 = new Sprite(16, 0, 0, SpriteSheet.tiles);
	public static Sprite plain2 = new Sprite(16, 0, 1, SpriteSheet.tiles);
	public static Sprite grass1 = new Sprite(16, 1, 0, SpriteSheet.tiles);
	public static Sprite grass2 = new Sprite(16, 1, 1, SpriteSheet.tiles);
	public static Sprite redFlower1 = new Sprite(16, 2, 0, SpriteSheet.tiles);
	public static Sprite pinkFlower1 = new Sprite(16, 2, 1, SpriteSheet.tiles);
	public static Sprite rock1 = new Sprite(16, 3, 0, SpriteSheet.tiles);
	public static Sprite rock2 = new Sprite(16, 3, 1, SpriteSheet.tiles);
	public static Sprite hedge1 = new Sprite(16, 4, 0, SpriteSheet.tiles);
	public static Sprite hedge2 = new Sprite(16, 4, 1, SpriteSheet.tiles);
	public static Sprite bricks1 = new Sprite(16, 5, 0, SpriteSheet.tiles);
	public static Sprite bricks2 = new Sprite(16, 5, 1, SpriteSheet.tiles);
	public static Sprite flooring1 = new Sprite(16, 6, 0, SpriteSheet.tiles);
	public static Sprite flooring2 = new Sprite(16, 6, 1, SpriteSheet.tiles);
	
	//projectiles
	public static Sprite fireball = new Sprite(16, 0, 5, SpriteSheet.tiles);
	
	//particles
	public static Sprite normalParticle = new Sprite(3, 0xffaaaaaa);
	
	//player sprite
	public static Sprite playeru = new Sprite(16, 0, 2, SpriteSheet.tiles);
	public static Sprite playerr = new Sprite(16, 1, 2, SpriteSheet.tiles);
	public static Sprite playerd = new Sprite(16, 2, 2, SpriteSheet.tiles);
	public static Sprite playerl = new Sprite(16, 3, 2, SpriteSheet.tiles);
	public static Sprite playeru0 = new Sprite(16, 0, 3, SpriteSheet.tiles);
	public static Sprite playerr0 = new Sprite(16, 1, 3, SpriteSheet.tiles);
	public static Sprite playerd0 = new Sprite(16, 2, 3, SpriteSheet.tiles);
	public static Sprite playerl0 = new Sprite(16, 3, 3, SpriteSheet.tiles);
	public static Sprite playeru1 = new Sprite(16, 0, 4, SpriteSheet.tiles);
	public static Sprite playerr1 = new Sprite(16, 1, 4, SpriteSheet.tiles);
	public static Sprite playerd1 = new Sprite(16, 2, 4, SpriteSheet.tiles);
	public static Sprite playerl1 = new Sprite(16, 3, 4, SpriteSheet.tiles);
	
	//the voidsprite
	public static Sprite voidSprite= new Sprite(16, 0x0000ff);
	
	

		/*
		 * These are all of the methods
		 */
	public Sprite(int size, int x, int y, SpriteSheet sheet){
		SIZE = size;
		this.width = size;
		this.height = size;
		pixels = new int[SIZE * SIZE];
		this.x = x * size;
		this.y = y * size;
		this.sheet = sheet;
		load();
	}//end sprite()
	
	public Sprite(int width, int height, int color){
		SIZE = 0;//not used
		this.width = width;
		this.height = height;
		pixels = new int[width * height];
		setColor(color);
		
	}
	
	public Sprite(int size, int color){
		SIZE = size;
		this.width = size;
		this.height = size;
		pixels = new int[SIZE * SIZE];
		setColor(color);
	}
	
	private void setColor(int color) {
		for (int i = 0; i < width * height; i++){
			pixels[i] = color;
		}
	}
	
	public int getWidth(){
		return width;
	}
	
	public int getHeight(){
		return height;
	}

	private void load() {//extracts a single sprite out of the sprite sheet
		for (int y = 0; y < SIZE; y++){
			for (int x = 0; x < SIZE; x++){
				pixels[x + y * SIZE] = sheet.pixels[(x + this.x) + (y + this.y) * sheet.SIZE];
			}//end x loop
		}//end y loop
	}//end load()

}//end Sprite class
