package garcia.alex.talia.graphics;

import java.awt.image.BufferedImage;
import java.io.IOException;
import javax.imageio.ImageIO;

public class SpriteSheet {
	
		/*
		 * These are all of the declared and/or initialized variables
		 */
	private String path;
	public final int SIZE;
	public int[] pixels;
	public static SpriteSheet tiles = new SpriteSheet("/textures/sheets/spritesheet2.png", 256);
	
		/*
		 * These are all of the methods
		 */
	public SpriteSheet(String path, int size){
		this.path = path;
		this.SIZE = size;
		pixels = new int[SIZE * SIZE];
		load();
	}//end spritesheet
	
	private void load() {
		try {
			BufferedImage image = ImageIO.read(SpriteSheet.class.getResource(path));
			int w = image.getWidth();
			int h = image.getHeight();
			image.getRGB(0, 0, w, h, pixels, 0, w);
		} catch (IOException e) {
			e.printStackTrace();
		}//end catch
	}//end load

}//end spritesheet class
