package garcia.alex.talia.level.tile;

import garcia.alex.talia.graphics.Screen;
import garcia.alex.talia.graphics.Sprite;

public abstract class Tile {

	/*
	 * These are all of the declared and/or initialized variables
	 */
	public int x, y;
	public Sprite sprite;
	public static Tile plain1 = new PlainTile(Sprite.plain1);
	public static Tile plain2 = new PlainTile(Sprite.plain2);
	public static Tile grass1 = new GrassTile(Sprite.grass1);
	public static Tile grass2 = new GrassTile(Sprite.grass2);
	public static Tile redFlower1 = new FlowerTile(Sprite.redFlower1);
	public static Tile pinkFlower1 = new FlowerTile(Sprite.pinkFlower1);
	public static Tile rock1 = new RockTile(Sprite.rock1);
	public static Tile rock2 = new RockTile(Sprite.rock2);
	public static Tile hedge1 = new HedgeTile(Sprite.hedge1);
	public static Tile hedge2 = new HedgeTile(Sprite.hedge2);
	public static Tile bricks1 = new BrickTile(Sprite.bricks1);
	public static Tile bricks2 = new BrickTile(Sprite.bricks2);
	public static Tile flooring1 = new FloorTile(Sprite.flooring1);
	public static Tile flooring2 = new FloorTile(Sprite.flooring2);
	
	public static final int col_plain1 = 0xff00ff08;
//	public static final int col_plain2 = 0xff00ff09;
	public static final int col_grass1 = 0xff007f02;
//	public static final int col_grass2 = 0xff007f03;
	public static final int col_redFlower1 = 0xffff4828;
//	public static final int col_pinkFlower1 = 0xffff6dd8;
	public static final int col_rock1 = 0xff465054;
//	public static final int col_rock2 = 0xff465055;
	public static final int col_hedge1 = 0xff00bf03;
//	public static final int col_hedge2 = 0xff00bf04;
	public static final int col_bricks1 = 0xff9aafb7;
//	public static final int col_bricks2 = 0xff9aafb8;
	public static final int col_flooring1 = 0xffc67c21;
//	public static final int col_flooring2 = 0xffc67c22;
	
	
	public static Tile voidTile = new VoidTile(Sprite.voidSprite);
	
	/*
	 * These are all of the methods
	 */
	public Tile(Sprite sprite){
		this.sprite = sprite;
	}//end tile()
	
	public void render(int x, int y, Screen screen){
	}//end render
	
	public boolean solid(){
		return false;		
	}//end solid
	
}//end tile class
